//------------------------------------------------------------------------------
// parser.cpp - функции, осуществляющие распознавание
//------------------------------------------------------------------------------

#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include "scanner_ext.h"

//------------------------------------------------------------------------------

void er(int);

//------------------------------------------------------------------------------

bool Declaration();
bool Statement();
bool Etc_stmts();
bool No_lab_stmt();
bool Ass_stmt_continue_1();
bool Ass_stmt_continue_2();
bool Assign_stmt();
bool Variable();
bool Expression();
bool Addition();
bool Product();
bool Term();
bool Number();
bool Case_stmt();
bool Loop_stmt();
bool Guard_set();
bool Guard();
bool Read_stmt();
bool Write_stmt();
bool Specificator();
bool Goto_stmt();
bool Abort_stmt();

//------------------------------------------------------------------------------
bool Program() {
//_0:
    if(lc==kwBegin) {nxl(); goto _1;}
    return false;
  _1:
    if(Declaration()) {goto _2;}
    if(Statement()) {goto _2;}
    if(lc==lexSemicolon) {nxl(); goto _1;}
    if(lc==kwEnd) {nxl(); goto _end;}
    er(7); return false;
  _2:
    if(lc==lexSemicolon) {nxl(); goto _1;}
    if(lc==kwEnd) {nxl(); goto _end;}
    er(7); return false;
  _end:
    return true;
}

//------------------------------------------------------------------------------
bool Declaration() {
//_0:
    if(lc==kwVar) {nxl(); goto _1;}
    return false;
  _1:
    if(lc==lexId) {nxl(); goto _2;}
    er(8); return false;
  _2:
    if(lc==lexLftSqBr) {nxl(); goto _3;}
    if(lc==lexComma) {nxl(); goto _1;}
    if(lc==lexColon) {nxl(); goto _6;}
    er(8); return false;
  _3:
    if(lc==lexInt) {nxl(); goto _4;}
    er(8); return false;
  _4:
    if(lc==lexRghSqBr) {nxl(); goto _5;}
    er(8); return false;
  _5:
    if(lc==lexComma) {nxl(); goto _1;}
    if(lc==lexColon) {nxl(); goto _6;}
    er(8); return false;
  _6:
    if(lc==kwInt) {nxl(); goto _end;}
    if(lc==kwFloat) {nxl(); goto _end;}
    er(8); return false;
  _end:
    return true;
}

//------------------------------------------------------------------------------
bool Statement() {
//_0:
    if(lc==lexId) {nxl(); goto _1;}
    if(Etc_stmts()) {goto _end;}
    return false;
  _1:
    if(lc==lexColon) {nxl(); goto _2;}
    if(lc==lexLftSqBr) {nxl(); goto _3;}
    if(lc==lexComma) {nxl(); goto _4;}
    if(lc==lexAssign) {nxl(); goto _5;}
    er(9); return false;
  _2:
    if(No_lab_stmt()) {goto _end;}
	goto _end;
  _3:
    if(Ass_stmt_continue_1()) {goto _end;}
    er(9); return false;
  _4:
    if(Ass_stmt_continue_2()) {goto _end;}
    er(9); return false;
  _5:
    if(Expression()) {goto _end;}
    er(9); return false;
  _end:
    return true;
}

//------------------------------------------------------------------------------
bool No_lab_stmt() {
//_0:
    if(lc==kwSkip) {nxl(); goto _end;}
    if(Assign_stmt()) {goto _end;}
    if(Case_stmt())   {goto _end;}
    if(Loop_stmt())   {goto _end;}
    if(Read_stmt())   {goto _end;}
    if(Write_stmt())  {goto _end;}
    if(Goto_stmt())   {goto _end;}
    if(Abort_stmt())  {goto _end;}
    return false;
  _end:
    return true;
}

//------------------------------------------------------------------------------
bool Etc_stmts() {
//_0:
    if(lc==kwSkip) {nxl(); goto _end;}
    if(Case_stmt())   {goto _end;}
    if(Loop_stmt())   {goto _end;}
    if(Read_stmt())   {goto _end;}
    if(Write_stmt())  {goto _end;}
    if(Goto_stmt())   {goto _end;}
    if(Abort_stmt())  {goto _end;}
    return false;
  _end:
    return true;
}

//------------------------------------------------------------------------------
bool Ass_stmt_continue_1() {
//_0:
    if(Expression()) {goto _1;}
    return false;
  _1:
    if(lc==lexRghSqBr) {nxl(); goto _2;}
    er(10); return false;
  _2:
    if(lc==lexComma) {nxl(); goto _3;}
    if(Expression()) {goto _end;}
    er(10); return false;
  _3:
    if(Ass_stmt_continue_2()) {goto _end;}
    er(10); return false;
  _end:
    return true;
}

//------------------------------------------------------------------------------
bool Ass_stmt_continue_2() {
//_0:
    if(Assign_stmt()) {goto _1;}
    return false;
  _1:
    if(lc==lexComma) {nxl(); goto _2;}
    er(11); return false;
  _2:
    if(Expression()) {goto _end;}
    er(11); return false;
  _end:
    return true;
}

//------------------------------------------------------------------------------
bool Assign_stmt() {
//_0:
    if(Variable()) {goto _1;}
    return false;
  _1:
    if(lc==lexAssign) {nxl(); goto _4;}
    if(lc==lexComma)  {nxl(); goto _2;}
    er(12); return false;
  _2:
    if(Assign_stmt()) {goto _3;}
    er(12); return false;
  _3:
    if(lc==lexComma) {nxl(); goto _4;}
    er(12); return false;
  _4:
    if(Expression()) {goto _end;}
    er(12); return false;
  _end:
    return true;
}

//------------------------------------------------------------------------------
bool Variable() {
//_0:
    if(lc==lexId) {nxl(); goto _1;}
    return false;
  _1:
    if(lc==lexLftSqBr) {nxl(); goto _2;}
    goto _end;
  _2:
    if(Expression()) {goto _3;}
    er(13); return false;
  _3:
    if(lc==lexRghSqBr) {nxl(); goto _end;}
    er(13); return false;
  _end:
    return true;
}

//------------------------------------------------------------------------------
bool Expression() {
//_0:
    if(Addition()) {goto _1;}
    return false;
  _1:
    if(lc==lexEQ) {nxl(); goto _2;}
    if(lc==lexGT) {nxl(); goto _2;}
    if(lc==lexLT) {nxl(); goto _2;}
    if(lc==lexNE) {nxl(); goto _2;}
    if(lc==lexGE) {nxl(); goto _2;}
    if(lc==lexLE) {nxl(); goto _2;}
    goto _end;
  _2:
    if(Addition()) {goto _1;}
    er(14); return false;
  _end:
    return true;
}


//------------------------------------------------------------------------------
bool Addition() {
//_0:
    if(Product()) {goto _1;}
    return 0;
  _1:
    if(lc==lexPlus)  {nxl(); goto _2;}
    if(lc==lexMinus) {nxl(); goto _2;}
    goto _end;
  _2:
    if(Product()) {goto _1;}
    er(15); return false;
  _end:
    return true;

}

//------------------------------------------------------------------------------
bool Product() {
//_0:
    if(Term()) {goto _1;}
    return 0;
  _1:
    if(lc==lexStar) {nxl(); goto _2;}
    if(lc==lexSlash) {nxl(); goto _2;}
    if(lc==lexPercent) {nxl(); goto _2;}
    goto _end;
  _2:
    if(Term()) {goto _1;}
    er(16); return false;
  _end:
    return true;
}

//------------------------------------------------------------------------------
bool Term() {
//_0:
    if(lc==lexMinus)    {nxl(); goto _1;}
    if(lc==lexLftRndBr) {nxl(); goto _2;}
    if(Number())   {goto _end;}
    if(Variable()) {goto _end;}
    return false;
  _1:
    if(lc==lexLftRndBr) {nxl(); goto _2;}
    if(Number())   {goto _end;}
    if(Variable()) {goto _end;}
    er(17); return false;
  _2:
    if(Expression()) {goto _3;}
    er(17); return false;
  _3:
    if(lc==lexRghRndBr) {nxl(); goto _end;}
    er(17); return false;
  _end:
    return true;
}

//------------------------------------------------------------------------------
bool Number() {
//_0:
    if(lc==lexInt)   {nxl(); goto _end;}
    if(lc==lexFloat) {nxl(); goto _end;}
    return false;
  _end:
    return true;
}

//------------------------------------------------------------------------------
bool Case_stmt() {
//_0:
    if(lc==kwCase) {nxl(); goto _1;}
    return false;
  _1:
    if(lc==kwEnd) {nxl(); goto _end;}
    if(Guard_set()) {goto _2;}
    er(18); return false;
  _2:
    if(lc==kwEnd) {nxl(); goto _end;}
    er(18); return false;
  _end:
    return true;
}

//------------------------------------------------------------------------------
bool Loop_stmt() {
//_0:
    if(lc==kwLoop) {nxl(); goto _1;}
    return false;
  _1:
    if(lc==kwEnd) {nxl(); goto _end;}
    if(Guard_set()) {goto _2;}
    er(19); return false;
  _2:
    if(lc==kwEnd) {nxl(); goto _end;}
    er(19); return false;
  _end:
    return true;
}

//------------------------------------------------------------------------------
bool Guard_set() {
//_0:
    if(Guard()) {goto _1;}
    return false;
  _1:
    if(lc==kwOr) {nxl(); goto _2;}
    goto _end;
  _2:
    if(Guard()) {goto _1;}
    er(20); return false;
  _end:
    return true;
}

//------------------------------------------------------------------------------
bool Guard() {
//_0:
    if(Expression()) {goto _1;}
    return false;
  _1:
    if(lc==lexArrow) {nxl(); goto _2;}
    er(21); return false;
  _2:
    if(Statement()) {goto _3;}
    if(lc==lexSemicolon) {nxl(); goto _2;}
    goto _end;
  _3:
    if(lc==lexSemicolon) {nxl(); goto _2;}
    goto _end;
  _end:
    return true;
}

//------------------------------------------------------------------------------
bool Read_stmt() {
//_0:
    if(lc==kwRead) {nxl(); goto _1;}
    return false;
  _1:
    if(Variable()) {goto _2;}
    er(22); return false;
  _2:
    if(lc==lexComma) {nxl(); goto _1;}
    goto _end;
  _end:
    return true;
}

//------------------------------------------------------------------------------
bool Write_stmt() {
//_0:
    if(lc==kwWrite) {nxl(); goto _1;}
    return false;
  _1:
    if(lc==lexString) {nxl(); goto _2;}
    if(Expression()) {goto _2;}
    if(Specificator()) {goto _2;}
    er(23); return false;
  _2:
    if(lc==lexComma) {nxl(); goto _1;}
    goto _end;
  _end:
    return true;
}

//------------------------------------------------------------------------------
bool Specificator() {
//0:
    if(lc==kwSpace) {nxl(); goto _1;}
    if(lc==kwTab)   {nxl(); goto _1;}
    if(lc==kwSkip)  {nxl(); goto _1;}
    return false;
  _1:
    if(Expression()) {goto _end;}
    goto _end;
  _end:
    return true;
}

//------------------------------------------------------------------------------
bool Goto_stmt() {
//_0:
    if(lc==kwGoto) {nxl(); goto _1;}
    return false;
  _1:
    if(lc==lexId) {nxl(); goto _end;}
    er(24); return false;
  _end:
    return true;
}


//------------------------------------------------------------------------------
bool Abort_stmt() {
//_0:
    if(lc==kwAbort) {nxl(); goto _1;}
    return false;
  _1:
    if(lc==lexString) {nxl(); goto _end;}
    goto _end;
  _end:
    return true;
}

//------------------------------------------------------------------------------
